* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:			complex_update.asm
* author:		Heiner Loellmann / Andreas Ropers
* date:			18.06.1999
* processor:		TMS320C54x
* project:		dsp-stone
* short description:	the program implements the operation d=c+a*b
*			all variables are complex :	
*			dr=cr+ar*br-ai*bi
*			di=ci+ar*bi+ai*br
*			(i: imaginary, r:real)

	.global startp
	.global prof
	.global endp
	.mmregs

	.data

a	.word 1			; ar
	.word 2			; ai

b	.word 1			; br
	.word 2			; bi

c	.word 5			; cr
	.word 5			; ci

d	.word 0			; dr
	.word 0			; di


	.text
startp:	
	STM #a	  , AR2
	STM #b	  , AR3
	STM #c	  , AR4
	STM #d	  , AR5
prof:	
		 ; evaluation of dr
	LD  *AR4+ , B		; cr -> B
	LMS *AR2+ , *AR3+	; B = B+ar*br
	LD  *AR2- , T
	MAS *AR3  , B		; B = B-ai*bi
	STL B     , *AR5+	; B -> dr
	
		 ; evaluation of di
	LD  *AR4  , B		; ci -> B
	LMS *AR2+ , *AR3-	; B = B+ar*bi
	LMS *AR2  , *AR3	; B = B+ai*br
	STL B     , *AR5	; B -> di
endp:	nop
	
	.end
	 
    
