* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:			n_complex_updates.asm
* author:		Heiner Loellmann/ Andreas Ropers

* date:			18.06.1999
* project:		dsp-stone
* processor:		TMS320C54x
* short description:	the program implements the operation d=c+a*b
*			where all variables are complex arrays:	
*				dr(k)=cr(k)+ar(k)*br(k)-ai(k*bi(k
*				di(k(k)0ci(k)+ar(k)*bi(k)+ai(k)*br(k)
*			(i: imaginaer, r:real, k = 1 ..N)

	.global startp
	.global prof
	.global endp
	.mmregs

N	.set 16			; number of taps
	
	.data

a	.word 1			; ar(1)
	.word 2			; ai(1)
	.word 3			; ....
	.word 4
	.word 5
	.word 6
	.word 7			; ar(4)
	.word 8			; ai(4)
	.word 1			
	.word 2			
	.word 3			
	.word 4
	.word 5
	.word 6
	.word 7		
	.word 8
	.word 1			
	.word 2		
	.word 3		
	.word 4
	.word 5
	.word 6
	.word 7		
	.word 8	
	.word 1		
	.word 2		
	.word 3
	.word 4
	.word 5
	.word 6
	.word 7			; ar(16)
	.word 8			; ai(16)
	
b	.word 1			; br(1)
	.word 2			; bi(1)
	.word 3			; ...
	.word 4
	.word 5
	.word 6
	.word 7			
	.word 8	
	.word 1			
	.word 2			
	.word 3			
	.word 4
	.word 5
	.word 6
	.word 7			
	.word 8	
	.word 1			
	.word 2		
	.word 3		
	.word 4
	.word 5
	.word 6
	.word 7			
	.word 8	
	.word 1			
	.word 2	
	.word 3		
	.word 4
	.word 5
	.word 6
	.word 7			; br(16)
	.word 8			; bi(16)

c	.word 10		; cr(1)
	.word 10		; ci(1)
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10
	.word 10		; cr(16)
	.word 10		; ci(16)

d	.word 0			; dr(1)
	.word 0			; di(1)
	.word 0			; ....
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0			; dr(16)
	.word 0			; di(16)


	.text
startp:	
	STM #a	 , AR2
	STM #b	 , AR3
	STM #c	 , AR4
	STM #d	 , AR5
prof:	
	STM #N-1,BRC
	RPTB loop		; for(k=1; k<=N; k++) {
		 ; evaluation of dr
	LD  *AR4+ , B		; cr(k) -> B
	LMS *AR2+ , *AR3+	; B = B+ar(k)*br(k)
	LD  *AR2- , T
	MAS *AR3  , B		; B = B-ai(k)*bi(k)
	STL B     , *AR5+	; B -> dr(k)
	
		 ; evaluation of di
	LD  *AR4+ , B		; ci(k) -> B
	LMS *AR2+ , *AR3-	; B = B+ar(k)*bi(k)
	LMS *AR2+ , *AR3+	; B = B+ai(k)*br(k)
	STL B     , *AR5+	; B -> di(k)

loop	MAR *AR3+ 		; increment AR3  } 
endp:	nop
	
	.end
	 
    
