* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:			real_update.asm
* author :		Heiner Loellmann/ Andreas Ropers

* date:			15.06.99
* project :		dsp-stone
* processor:		TMS320C54x
* short description :	realizes the equation:	d=c+a*b  (real values)
	

	.global startp
	.global prof
	.global endp
	.mmregs			;defines global symbolic names for the registers

	.data

coeff	.word 1 		; a
	.word 8 		; b
	.word 5			; c
	.word 0			; d

	
	.text
startp:	
	STM	#coeff , AR2	; pointer to a
	STM     #coeff+1, AR3	; pointer to b
	STM     #coeff+2, AR4	; pointer to c

prof:	nop
	LD      *AR4   , B	; c -> B
	LMS     *AR2   , *AR3	; B = B+a*b	
	STL	B      , *AR2(3); stores result to d
endp:	nop
	.end
